
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Csat_surveysDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const csat_surveys = await db.csat_surveys.create(
            {
                id: data.id || undefined,
        
        score: data.score
        ||
        null
            ,
            
        feedback: data.feedback
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        responded_at: data.responded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await csat_surveys.setTenant( data.tenant || null, {
            transaction,
        });
        
        await csat_surveys.setTicket( data.ticket || null, {
            transaction,
        });
        
        await csat_surveys.setContact( data.contact || null, {
            transaction,
        });
        
        await csat_surveys.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return csat_surveys;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const csat_surveysData = data.map((item, index) => ({
                id: item.id || undefined,
                
                score: item.score
            ||
            null
            ,
            
                feedback: item.feedback
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                responded_at: item.responded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const csat_surveys = await db.csat_surveys.bulkCreate(csat_surveysData, { transaction });

        // For each item created, replace relation files
        

        return csat_surveys;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const csat_surveys = await db.csat_surveys.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.feedback !== undefined) updatePayload.feedback = data.feedback;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.responded_at !== undefined) updatePayload.responded_at = data.responded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await csat_surveys.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await csat_surveys.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.ticket !== undefined) {
            await csat_surveys.setTicket(
              
              data.ticket,
              
              { transaction }
            );
        }
        
        if (data.contact !== undefined) {
            await csat_surveys.setContact(
              
              data.contact,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await csat_surveys.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return csat_surveys;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const csat_surveys = await db.csat_surveys.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (csat_surveys.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of csat_surveys) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of csat_surveys) {
                await record.destroy({transaction});
            }
        });


        return csat_surveys;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const csat_surveys = await db.csat_surveys.findByPk(id, options);

        if (!csat_surveys) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await csat_surveys.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await csat_surveys.destroy({
            transaction
        });

        return csat_surveys;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const csat_surveys = await db.csat_surveys.findOne(
            { where },
            { transaction },
        );

        if (!csat_surveys) {
            return csat_surveys;
        }

        const output = csat_surveys.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await csat_surveys.getTenant({
            transaction
        });
        
        
        output.ticket = await csat_surveys.getTicket({
            transaction
        });
        
        
        output.contact = await csat_surveys.getContact({
            transaction
        });
        
        
        output.organizations = await csat_surveys.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.support_tickets,
        as: 'ticket',
        
        where: filter.ticket ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ticket.split('|').map(term => Utils.uuid(term)) } },
            {
              ticket_number: {
                [Op.or]: filter.ticket.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.contacts,
        as: 'contact',
        
        where: filter.contact ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contact.split('|').map(term => Utils.uuid(term)) } },
            {
              email: {
                [Op.or]: filter.contact.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.feedback) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'csat_surveys',
                        'feedback',
                        filter.feedback,
                    ),
                };
            }
            

            
            

            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.responded_atRange) {
                const [start, end] = filter.responded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.csat_surveys.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'csat_surveys',
                        'feedback',
                        query,
                    ),
                ],
            };
        }

        const records = await db.csat_surveys.findAll({
            attributes: [ 'id', 'feedback' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['feedback', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.feedback,
        }));
    }

    
};

